﻿using Infragistics.Windows;
using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace DataGridPersons
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void Window_Loaded(object sender, RoutedEventArgs e)
        {
            List<Person> persons = new List<Person>();

            for (int i = 0; i < 50; i++)
            {
                persons.Add(new Person() { FirstName = "John" + i.ToString(), LastName = "Brown" + i.ToString(), Age = i });
            }

            xamDataGrid.DataSource = persons;
        }

        private void menuItemsCheckItems_Click(object sender, RoutedEventArgs e)
        {
            GroupByRecordPresenter groupByRecordPresenter = (GroupByRecordPresenter)((ContextMenu)((MenuItem)sender).Parent).PlacementTarget;

            List<Record> items = (groupByRecordPresenter.Record as GroupByRecord).ChildRecords.ToList();

            var person = ((DataRecord)items[0]).DataItem;
        }

        private void menuItemOpenItems_Click(object sender, RoutedEventArgs e)
        {

        }

        private void GRP_ContextMenuOpening(object sender, RoutedEventArgs e)
        {

        }

        private void GRP_PreviewMouseButtonDown(object sender, RoutedEventArgs e)
        {
            List<Record> items = ((GroupByRecord)(sender as GroupByRecordPresenter).Record).ChildRecords.ToList();

            for (int i = 0; i < items.Count; i++)
            {
                if (items[i].RecordType == RecordType.GroupByField)
                {
                    (((ContextMenu)grid.FindResource("contextMenu_GroupByRecordPresenter")).Items[0] as MenuItem).IsEnabled = false;
                    return;
                }
                else
                {
                    (((ContextMenu)grid.FindResource("contextMenu_GroupByRecordPresenter")).Items[0] as MenuItem).IsEnabled = true;
                }
            }
        }
    }

    public class Person
    {
        public Person()
        {
        }

        private string firstName;
        private string lastName;
        private int age;

        public string FirstName
        {
            get { return firstName; }
            set { firstName = value; }
        }

        public string LastName
        {
            get { return lastName; }
            set { lastName = value; }
        }

        public int Age
        {
            get { return age; }
            set { age = value; }
        }
    }
}